import type { IEncodeFeature, IModel } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
import type { IPointLayerStyleOptions } from '../../core/interface';
export declare function PointTriangulation(feature: IEncodeFeature): {
    vertices: number[];
    indices: number[];
    size: number;
};
export default class SimplePointModel extends BaseModel {
    getDefaultStyle(): Partial<IPointLayerStyleOptions>;
    protected getCommonUniformsInfo(): {
        uniformsArray: number[];
        uniformsLength: number;
        uniformsOption: {
            [key: string]: any;
        };
    };
    initModels(): Promise<IModel[]>;
    buildModels(): Promise<IModel[]>;
    protected registerBuiltinAttributes(): void;
}
